/* ------------------------------------------------------------------   */
/*  final.sas - FINAL PROJECT - modify this to do something interesting */
/* ------------------------------------------------------------------   */

%GLOBAL CHOICE;

/* for testing
%LET choice=a;
filename _webout 'c:\workshop\ws124\webout.htm';
end testing*/



options mprint;

           /* ---------------------------- */
           /* make a test dataset          */
           /* ---------------------------- */

data test;
input month  year hired fired profit loss;

cards;
1      1995.00       14.00        9.00       30000       20000
2      1995.00        9.00        6.00       41000       15000
3      1995.00       15.00       16.00       34000       24000
4      1995.00       17.00       17.00       27000       25000
5      1995.00        6.00       11.00       45000       23000
6      1995.00       20.00        5.00       31000        9000
7      1995.00       17.00        8.00       24000       10000
8      1995.00        9.00        8.00       39000       10000
9      1995.00        6.00       11.00       48000       14000
10     1995.00       16.00       19.00       38000       18000
11     1995.00       17.00       12.00       32000       14000
12     1995.00       11.00       13.00       26000       15000
1      1996.00        5.00        9.00       36000       10000
2      1996.00        8.00        7.00       41000        8000
3      1996.00        8.00       11.00       55000       12000
4      1996.00       11.00       13.00       53000       14000
5      1996.00       19.00       16.00       44000       29000
6      1996.00       12.00        7.00       45000       17000
7      1996.00       13.00        8.00       44000       18000
8      1996.00        9.00       10.00       56000       21000
9      1996.00        7.00       10.00       58000       21000
10     1996.00       11.00       18.00       55000       30000
11     1996.00       13.00       20.00       50000       34000
12     1996.00       16.00       19.00       46000       33000
1      1997.00        7.00       18.00       53000       32000
2      1997.00        8.00       17.00       52000       31000
3      1997.00       10.00       20.00       50000       35000
4      1997.00       10.00       15.00       51000       30000
5      1997.00       18.00       10.00       47000       28000
6      1997.00       20.00        9.00       43000       27000
7      1997.00       19.00        7.00       44000       25000
8      1997.00       18.00       11.00       45000       27000
9      1997.00       17.00       13.00       45000       29000
10     1997.00       20.00       16.00       42000       29000
11     1997.00       15.00        7.00       47000       23000
12     1997.00       10.00        8.00       54000       24000
;

run;
           /* ----------------------------------------------- */
           /* the first choice displays the dataset two ways: */
           /*  1. captures the output window (PROC PRINT)     */
           /*  2. with the ds2htm HTML formatting tool        */
           /* ----------------------------------------------- */
%MACRO CHOICEA;
 
title 'My final project -  Choice A - list the dataset examples ';

 %OUT2HTM(capture=on, window=output );
    proc print data=test; 
    run;
 %OUT2HTM(htmlfref=_webout,
             capture=off,
             window=output,
             runmode=s,
             bgtype=color,            /*background type               */
             ctext=#0000AA,             /* default text #rrggbb (HEX) */
             bg=#f3f7ff,                /*background                  */
             tcolor=#FF0000;            /*title                       */
             openmode=replace);

          /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */
 
 %DS2HTM(data=test,
          runmode=b,
          openmode=append,
          htmlfref=_webout,
          caption=this is the TEST dataset,
          tcolor=#AA0000,              /* title                        */
          obsnum=Y,                    /* observation numbers          */
          obgcolr=#AAAAAA,             /* obs. num.  background color  */
          ocolor=#000000,              /* obs. num.  text color        */
          ccolor=blue,                 /* caption color                */
          clbgcolr=#AAAAAA,            /* column head background color */
          clcolor=#000000,             /* column label text color      */
          tbbgcolr=cyan);              /* table background color       */

%MEND CHOICEA;

           /* ------------------------------------------------------------- */
           /* the second choice uses the "tabulate to HTML" formatting tool */
           /* ------------------------------------------------------------- */
%MACRO CHOICEB;
title 'My final project -  choice B PROC Tabulate example ';

  %TAB2HTM(capture=on);

    options linesize=96 pagesize=54 nocenter nodate nonumber;

    title 'Example: Tabulated TEST dataset';
    proc tabulate data=WORK.TEST  formchar='82838485868788898a8b8c'x;                                               
     table month   ALL                                                              
        ,(hired fired ) * ( 'MEAN' 'STD')                                                                                                                             
        ;                                                                       
     var hired fired ;                                                                  
     class month ;                                                                  
    run;            

  %TAB2HTM(capture=off, 
          runmode=s,
          openmode=replace,
          htmlfref=_webout,
          brtitle=tabulated TEST dataset,
          clbgcolr=#EEEEEE,            /* column head background color */
          clcolor=#000000,             /* column label text color      */
          rlbgcolr=#EEEEEE,            /* row head background color    */
          rlcolor=#000000,             /* row label text color         */
          bxbgcolr=#AAAAAA,            /* box cell background color    */
          bxcolor=#000000,             /* box cell text color         */
          center=Y);


%MEND CHOICEB;

           /* ---------------------------------------- */
           /* this prints out an error message         */
           /* ---------------------------------------- */
%MACRO OOPS;
title 'Your Error Message:';
  data _null_;
   file _webout;
   pick=symget('CHOICE');
   put 'Content-type: text/html'// 'Unknown choice:'/ pick;
  run;
%MEND OOPS;

           /* ----------------------------------------------------- */
           /* code selection is done in macro PICKONE which invokes */
           /* either the macro "CHOICEA" or "CHOICEB" or "OOPS"     */
           /* ----------------------------------------------------- */

%MACRO PICKONE;

%IF %upcase(%superq(CHOICE))=A %THEN %DO ;
  %CHOICEA;
%END;
%ELSE %IF %upcase(%superq(CHOICE))=B %THEN %DO;
  %CHOICEB;
%END;
%ELSE %DO;
  %OOPS;
%END;


%MEND PICKONE;
%PICKONE;


